<?php

namespace FiloBlu\Refilo\Remote;

use Magento\Framework\Exception\NoSuchEntityException;

/**
 * Class RelatedIndexer
 * @package FiloBlu\Refilo\Remote
 */
class RelatedIndexer extends AbstractIndexer
{

    public function getEntitiesToRemove(array $ids = [])
    {
    }

    public function beforeExecute(array $ids = [])
    {
    }

    public function postExecute(array $ids = [])
    {
    }

    /**
     * @param array $ids
     * @return mixed|void
     * @throws NoSuchEntityException
     */
    public function executeAction(array $ids)
    {
        try {
            $indexTemplate = $this->getGetRemoteIndexTemplate();
        } catch (\Exception $exception) {
            $this->logger->error($exception->getMessage(), ['exception' => $exception]);
            return;
        }

        $entities = $this->entityProviderFactory->create()->withIds($ids);
        $collection = $indexTemplate->render();
        $this->write($entities, $collection);
    }

    /**
     * @param $entities
     * @param $collection
     * @return mixed|void
     * @throws NoSuchEntityException
     */
    protected function write($entities, $collection)
    {
        $this->getConnector()->create($entities, $collection);
    }

    /**
     * @return string
     */
    protected function getClass(): string
    {
        return __CLASS__;
    }
}
